/*
 * Extra Windows Position Manager for Gaim (Mostly MS Windows)
 *
 * Gaim is the legal property of its developers, whose names are too numerous
 * to list here.  Please refer to the COPYRIGHT file distributed with this
 * source distribution.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define SIZEOF_ARRAY(ar)        (sizeof(ar)/sizeof((ar)[0]))

typedef struct _extpos_data_t   extpos_data_t;
typedef struct _GList           GList;
typedef struct _GtkListStore    GtkListStore;

/*
 * win_hotkeys.c
 */
typedef void (CALLBACK_HOTKEY)(extpos_data_t *extpos_data);

typedef enum _HOTKEY_ID
{
    IDHK_TOGGLE_BLIST,
    IDHK_CYCLE_CONVS,
    IDHK_Max
} HOTKEY_ID;

typedef struct _HOTKEY_DATA
{
    int mods;
    int vk;
    CALLBACK_HOTKEY *callback;
} HOTKEY_DATA;

void extpos_register_hotkey(extpos_data_t *extpos_data,
    HOTKEY_ID hotkey_id, int mods, int vk,
    CALLBACK_HOTKEY *hotkey_callback);
void extpos_close_hotkeys(extpos_data_t *extpos_data);

/*
 * winhook.c
 */
typedef void (CALLBACK_HWND_CREATED)(HWND hwnd);
typedef void (CALLBACK_HWND_MOVESIZED)(HWND hwnd, RECT *rc);

int hook_init(extpos_data_t *extpos_data,
                CALLBACK_HWND_CREATED *hwnd_created,
                CALLBACK_HWND_MOVESIZED *hwnd_movesized);
void hook_close(extpos_data_t *extpos_data);

/*
 * extpos.c
 */
typedef struct _extpos_data_t
{
    // Should be EXTPOS_MAGIC_ID or something has gone wrong
    int is_loaded;

    HHOOK shell_hook;
    HHOOK cbt_hook;
    CALLBACK_HWND_CREATED *hwnd_created;
    CALLBACK_HWND_MOVESIZED *hwnd_movesized;

    HWND  hotkey_hwnd;
    GList *last_conv_list;
    HOTKEY_DATA hotkey_data[IDHK_Max];

    GtkListStore *model;
} extpos_data_t;

extern extpos_data_t g_extpos_data;